// Генератор для теста №60.

#include <cassert>
#include <ctime>
#include <bits/stdc++.h>

using namespace std;

int main() {
    srand(time(nullptr));
    int n, m, rn, rm, k, rk;
    cin >> rn >> rm >> rk;
    int tests = 0;
    int worst = 0;
    int max_k = 0;
    while (1) {
        tests++;
        n = rand() % 20 - 10 + rn;
        m = rand() % 20 - 10 + rm;
        k = rand() % 40 - 20 + rk;

        vector<pair<int, int>> a;
        const int CHAINS = 1;
        int chain_size = (k - a.size()) / CHAINS;
        for (int chain = 0; chain < CHAINS; chain++) {
            int u = rand() % n, d = 0;
            for (int i = 0; i < chain_size; i++) {
                int v = rand() % (d ? n : m);
                a.push_back(make_pair((d ? v : u), (d ? u : v)));
                u = v; d = 1 - d;
            }
        }
        while (a.size() < k) {
            a.push_back(make_pair(rand() % n, rand() % m));
        }
        assert(a.size() == k);

        vector<int> c1(n), c2(m);
        for (auto o : a) {
            c1[o.first]++;
            c2[o.second]++;
        }
        int t = max(*max_element(c1.begin(), c1.end()), *max_element(c2.begin(), c2.end()));

        int attempts = 0;
        while (1) {
            attempts++;
            const int N = 1000;
            vector<bitset<N>> b(n), c(m);
            bool ok = 1;
            vector<vector<pair<int, int>>> ans(t);
            for (auto o : a) {
                int id = (~(b[o.first] | c[o.second]))._Find_first();
                if (id >= t) {
                    ok = 0;
                    break;
                }
                b[o.first][id] = 1;
                c[o.second][id] = 1;
                ans[id].push_back(o);
            }
            random_shuffle(a.begin(), a.end());
            if (ok) {
                break;
            }
        }
        if (attempts > worst) {
            worst = attempts;
            max_k = k;
            cerr << "found solution in " << attempts << " (" << worst
                 << ", k=" << max_k << ") attempts for test " << tests << endl;
            cerr << n << " " << m << " " << k << endl;
            for (int i = 0; i < k; i++) {
                cerr << a[i].first + 1 << " " << a[i].second + 1 << endl;
            }
            cerr << endl;

        }
        cout << attempts << " (" << worst
             << ", k=" << max_k << ") test " << tests << endl;
    }
}
